class Panel::PersonalResearch::Plugin::ResearchsController < OrbitBackendController
  include AdminHelper
  include OrbitControllerLib::DivisionForDisable
  
  before_filter :authenticate_user!

  def index

  
  @filter = params[:filter]
  new_filter = params[:new_filter]

  if @filter && params[:clear]
    @filter.delete(params[:type])
  elsif @filter && new_filter
    if @filter.has_key?(new_filter[:type]) && @filter[new_filter[:type]].include?(new_filter[:id].to_s)
      @filter[new_filter[:type]].delete(new_filter[:id].to_s)
    elsif @filter.has_key?(new_filter[:type])
      @filter[new_filter[:type]] << new_filter[:id].to_s
    else
      @filter.merge!({new_filter[:type] => [new_filter[:id].to_s]})
    end
  elsif new_filter
    @filter = {new_filter[:type] => [new_filter[:id].to_s]}
  end
  
  # @researchs = (params[:sort] || @filter) ? get_sorted_and_filtered("research",:create_user_id => current_user.id) : get_viewable("research",:create_user_id => current_user.id)
  @researchs = @researchs = Research.all.where(:create_user_id => current_user.id).page(params[:page]).per(10)

  @tags = get_tags

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @researchs }
      format.js
    end
  end

  # GET /researchs/1
  # GET /researchs/1.xml
  def show
    @research = Research.find(params[:id])
    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @research }
    end
  end

  # GET /researchs/new
  # GET /researchs/new.xml
  def new
  
    @research = Research.new
	
    @tags = get_tags

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @research }
    end
  end

  # GET /researchs/1/edit
  def edit
    @research = Research.find(params[:id])
	
    @tags = get_tags
  end

  # POST /researchs
  # POST /researchs.xml
  def create
	
	@tags = get_tags
  
    @research = Research.new(params[:research])
	
    @research.create_user_id = current_user.id
    @research.update_user_id = current_user.id

    respond_to do |format|
      if @research.save
        format.html { redirect_to(panel_personal_research_plugin_researchs_url) }
        format.xml  { render :xml => @research, :status => :created, :location => @research }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @research.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /researchs/1
  # PUT /researchs/1.xml
  def update
    @research = Research.find(params[:id])
	
    @research.update_user_id = current_user.id
	
	params[:research][:tag_ids] ||=[]

    respond_to do |format|
      if @research.update_attributes(params[:research])
        format.html { redirect_to(panel_personal_research_plugin_researchs_url) }
		# format.js  { render 'toggle_enable' }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @research.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /researchs/1
  # DELETE /researchs/1.xml
  def destroy
    @research = Research.find(params[:id])
    @research.destroy

    respond_to do |format|
      format.html { redirect_to(panel_personal_research_plugin_researchs_url) }
      # format.xml  { head :ok }
      format.js
    end
  end

  def delete
    if params[:ids]
      researchs = Research.any_in(:_id => params[:ids]).destroy_all
    end
    redirect_to panel_personal_research_plugin_researchs_url(:direction => params[:direction], :sort => params[:sort], :sort_options => params[:sort_options])
  end
  
  protected
 

  # def get_index_categories(id = nil)
  #   @bulletin_categorys = []
  #   if(is_manager? || is_admin?)
  #     @bulletin_categorys = (id ? BulletinCategory.admin_manager_all.find(id).to_a : BulletinCategory.admin_manager_all)
  #   elsif is_sub_manager?
  #     @bulletin_categorys = BulletinCategory.all
  #   end
  #   @bulletin_categorys
  # end


  # def get_categorys(id = nil)
  #   @research_categorys = []
  #   if(is_manager? || is_admin?)
  #     @research_categorys = (id ? ResearchCategory.admin_manager_all.find(id).to_a : ResearchCategory.admin_manager_all))
  #   elsif is_sub_manager?
  #     @research_categorys = ResearchCategory.all.authed_for_user(current_user,'edit')
  #   end
  #   if @research_categorys.empty? && params[:action] != "index"
  #       flash[:alert] = t("announcement.error.no_avilb_cate_for_posting")
  #       redirect_to :action => :index
  #   end
  # end
  
end
